Subject: Re: bug#71332: guix gc delete order

From: Guillaume Le Vaillant <[email-masked]>
Date: Mon, 03 Jun 2024 09:30:34 +0000

Nicolas Graves via Bug reports for GNU Guix <[email-masked]> skribis:

> Hi Guix,
>
> I feel the way `guix gc` choose its files to delete quite
> inconvenient. For instance, when developping big programs locally, I
> often find myself missing space, but when I will `guix gc -C30G`,
> instead of the expected unused items (not present in any profile, just
> built but discarded as the package I'm building is updated for
> instance), I will instead loose most of the native-inputs that are
> needed to build my `guix home` and `guix system`.
>
> This make me stuck in an endless loop of removing / redownloading over
> and over the same native-inputs, while my intention is first to remove
> files that aren't these native-inputs.
>
> I haven't delved into `guix gc` yet, how hard is that issue to solve? 

Hi.
Is the guix-daemon of your system started with the
"--gc-keep-derivations=yes" and "--gc-keep-outputs=yes" options?
It should prevent "guix gc" from deleting the build dependencies of live
profiles.